use piston_window::math::*;

const BULLET_POLY: &'static [[Scalar; 2]] = &[
    [-1.5, -1.5],
    [-1.5, 1.5],
    [1.5, 1.5],
    [1.5, -1.5]
];

#[derive(Debug)]
pub struct Bullet {
    pub position: Vec2d,
    pub velocity: Vec2d,
    pub ttl: Scalar,
    pub geometry: &'static [[Scalar; 2]]
}

impl Bullet {
    pub fn new(loc: Vec2d, velocity: Vec2d, ttl: Scalar) -> Self {
        Bullet {
            position: loc,
            velocity: velocity,
            ttl: ttl,
            geometry: BULLET_POLY
        }
    }

    pub fn update(&mut self, dt: Scalar) -> Scalar {
        self.position = add(self.position, self.velocity);
        self.ttl -= dt;
        self.ttl
    }
}
